
      PROGRAM TDSYEV25
*
*       ணࠬ   PDSYEV2
*
      include 'mpif.h'
*  ⠭ - ࠬ  ..
      INTEGER            LWORK, NOUT, MEMSIZE, NIN, NPR
      PARAMETER          ( MEMSIZE = 20000, LWORK = 70,
     $                   NOUT =13, NIN = 11, NPR = 6 )
*
      CHARACTER          UPLO
      PARAMETER          ( UPLO = 'L' )
*
*  ६
      INTEGER            CTXT, I, IAM, INFO, IPA, IPZ, IPW,
     $                   IPWORK, MYCOL, MYROW, NP, NQ,
     $                   N, NB, NPCOL, NPROCS, NPROW, IA, JA, IZ, JZ
*
*  ᨢ
      INTEGER            DESCA( 9 ), DESCZ( 9 )
      DOUBLE PRECISION   MEM( MEMSIZE ), WORK1(7)
*
* 譨 ணࠬ
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDLAPRNT, PDLAREAD,
     $                   PDLAWRITE, NUMROC, PDSYEV2
*
* 믮塞 
*
* ⠭ 
*
      N = 7
      NB = 2
      NPROW = 2
      NPCOL = 2
      IA = 1
      JA = 1
      IZ = 1
      JZ = 1
*
* 樠  BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
*
        IF( NPROCS.LT.1 ) THEN
           CALL BLACS_SETUP( IAM, NPROW*NPCOL )
        END IF
*
* 樠 ⥪ BLACS'  ⪨ ᮢ
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨      ⥪,
* 室   ணࠬ
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
*
* ᫥ ࠧ஢  ⥩   A    
*
      NP = NUMROC( N, NB, MYROW, 0, NPROW )
      NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
*
* 樠 ਯ஢   A  Z
*
      CALL DESCINIT( DESCA, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
      CALL DESCINIT( DESCZ, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
*
* ।   MEM
*
* ⥫    ᨢ ᮡ⢥ 祭
      IPW = 1
* ⥫    쭮    A
      IPA = IPW + N
* ⥫    ᨢ ᮡ⢥ ஢
      IPZ = IPA + DESCA(9)*NQ
* ⥫  ࠡ稩 ᨢ
      IPWORK = IPZ + DESCZ(9)*NQ
*
* ⥭  䠩  ।  A
*
      CALL PDLAREAD('tdsyev25.dat', MEM(IPA), DESCA, 0, 0, MEM(IPWORK))
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )
         WRITE( NPR, FMT = 9998 )N, N, NB, NB
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NPR, FMT = * ) ' 室  '
         WRITE( NPR, FMT = 9988 ) UPLO
         WRITE( NPR, FMT = * )'   IPW,   IPA,   IPZ,   IPWORK'
         WRITE( NPR, FMT = 9994 )IPW, IPA, IPZ, IPWORK
         WRITE( NPR, FMT = * ) '  DESCA'
         WRITE( NPR, FMT = 9985 )DESCA
         WRITE( NPR, FMT = * ) '  DESCZ'
         WRITE( NPR, FMT = 9985 )DESCZ
         WRITE( NPR, FMT = * ) '  A'
      END IF
*
 9994 FORMAT( / 4I7 /)
 9985 FORMAT( / 9I5 /)
* 9984 FORMAT( / ' MEM(IPWORK) = ', D16.5 /)
 9988 FORMAT( / ' UPLO = ', A /)
*
      CALL PDLAPRNT( N, N, MEM(IPA), IA, JA, DESCA, 0, 0, 'A',
     $               NPR, WORK1 )
*
* ᫥ ᮡ⢥ 祭  ᮡ⢥ ஢
*
      CALL PDSYEV2( UPLO, N, MEM(IPA), IA, JA, DESCA, MEM(IPW),
     $              MEM(IPZ), IZ, JZ, DESCZ, MEM(IPWORK), LWORK, INFO)
*
*  १⮢
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
         WRITE( NPR, FMT = 9996 )INFO
*         WRITE( NPR, FMT = 9984 )MEM(IPWORK)
         WRITE( NPR, FMT = * ) ' ᮡ⢥ ᫠'
*
         DO 10 I = 1, N
            PRINT *, ' W(', I, ')=', MEM( IPW+I-1 ), ';'
   10    CONTINUE
         WRITE( NPR, FMT = * ) ' ᮡ⢥ '
      END IF
*
*  ᮡ⢥ ஢
*
      CALL PDLAPRNT( N, N, MEM(IPZ), IZ, JZ, DESCZ, 0, 0, 'Z', NPR,
     $               WORK1 )
*
*   䠩 १⮢ ࠡ ணࠬ PDSYEV2.f
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         OPEN( NOUT, FILE = 'tdsyev25.res', STATUS = 'UNKNOWN' )
         WRITE( NOUT, FMT = * ) ' ᮡ⢥ ᫠'
         DO 11 I = 1, N
            WRITE( NOUT, FMT = * ) MEM( IPW+I-1 )
   11    CONTINUE
         WRITE( NOUT, FMT = * ) ' ᮡ⢥ '
      END IF
*
      CALL PDLAWRITE( 'tdsyev25.res', N, N, MEM(IPZ), 1, 1, DESCZ,
     $                0, 0, MEM(IPWORK) )
*
      CALL BLACS_GRIDEXIT( CTXT )
   20 CONTINUE
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( 'W=diag([', 4D16.12, //']);' )
*
 9992 FORMAT( / '  ணࠬ PDSYEV2' )
 9998 FORMAT( / ' ᫥  ᮡ⢥ 祭  ᮡ⢥',
     $  ' ஢   A,' //
     $      '  A - ᨬ筠  ',
     $      I2, '  ', I2,', ࠧ  ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO  = ', I6 /)
      STOP
      END
